/*------------------------------------------------*/
/* 40socket/client.c                              */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <regex.h>
#include "connection.h"
#include "../definice.h"
#include "check-new-version.h"
#include "get-ip-address.h"

#define MAX_VER_LENGTH 10
#define CLIENT_SERVER_PORT 80


/**
* @TODO pouzit XML parser
*/
static bool
parseVersion (const char const *xml, char *ver, size_t size)
{
  regex_t preg;
  regmatch_t pmatch[4];
  int ret;
  ret =
    regcomp (&preg,
	     "<string>(<!\\[CDATA\\[)?([0-9]+.[0-9]{1,2}.[0-9]{2})(]]>)?</string>",
	     REG_EXTENDED);
  if (ret)
    {
      regfree (&preg);
      return false;
    }
  ret =
    regexec (&preg, xml, sizeof (pmatch) / sizeof (regmatch_t), pmatch, 0);
  regfree (&preg);
  if (ret == REG_NOMATCH)
    return false;
  if (ret)
    {
      return false;		// nejaka jina chyba
    }
  ret = 1 + pmatch[2].rm_eo - pmatch[2].rm_so;
  if (size > ret)
    size = ret;
  memcpy (ver, &xml[pmatch[2].rm_so], size);
  ver[size - 1] = '\0';
  return true;
}


bool
httpCheckNewVersion (char **version, bool print_warning)
{
  char *content;
  static char ver[MAX_VER_LENGTH];
  *version = NULL;
  char *client_server_ipv4 = getIpAddress (HTTP_HOST, print_warning);
  if (!client_server_ipv4)
    return false;

  descriptors fd =
    connectClientToServer (client_server_ipv4, CLIENT_SERVER_PORT);
  if (fd.r < 0 || fd.w < 0)
    {
      if (print_warning)
	fprintf (stderr, "Connection failed.\n");
      return false;
    }
  content = clientWork (&fd);
  disconnectClientFromServer (&fd);

  if (parseVersion (content, ver, MAX_VER_LENGTH))
    {
      *version = ver;
    }
  free (content);

  if (*version == NULL)
    {
      return false;
    }
  return strcmp (*version, VER);
}

/*------------------------------------------------*/
