/* Copyright (c) 2004 Petr Bilek
   Tento program je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor kontrola_test_lekce.c */

#include "../definice.h"
#include "../struktury.h"
#include "../lib.h"
#include "chlib.h"

int
kontrola_test_lekce ()
{
  int l, i;
  type_informace infot, infol;
  printf ("\nKONTROLA INFO TEST + INFO LEKCE\n");


  for (l = 1; l <= LEKCE; l++)
    {
      if (nacti_info (l, &infol, jmeno_info_lekce ()))
	{
	  fprintf (stderr, "Nelze nacist informace pro LEKCI %i\n", l);
	  return 1;
	}
      if (infol.zavislost_na)
	{
	  if (nacti_info (infol.zavislost_na, &infot, jmeno_info_testu ()))
	    {
	      fprintf (stderr, "Nelze nacist informace pro TEST %i\n",
		       infol.zavislost_na);
	      return 1;
	    }
	  if (!obsahuje_vse (infol.pismena, infot.pismena, 1))
	    {
	      fprintf (stderr,
		       "LEKCE %i neobsahuje vsechny pismana TESTU %i\n",
		       l, infol.zavislost_na);
	      return 1;
	    }

	  if (infot.zavislost_na >= l)
	    {
	      fprintf (stderr, "LEKCE %i zavisi na TESTU %i, ale tento "
		       "TEST na LEKCI %i\n", l, infol.zavislost_na,
		       infot.zavislost_na);
	      return 1;
	    }
	  if (!infol.mezernik && infot.mezernik)
	    fprintf (stderr, "LEKCI %i nelze ukoncit mezernikem, ale "
		     "predchazejici TEST %i lze!\n", l, infol.zavislost_na);
	  for (i = 0; i < 5; i++)
	    if (infol.presnost[i] > infot.presnost[i])
	      {
		fprintf (stderr,
			 "LEKCE/TEST %i/%i: presnost nedava smysl (%i > %i)\n",
			 l, infol.zavislost_na, infol.presnost[i],
			 infot.presnost[i]);
	      }
	  for (i = 0; i < 5; i++)
	    if (infol.rychlost[i] < infot.rychlost[i])
	      {
		fprintf (stderr,
			 "LEKCE/TEST %i/%i: rychlost nedava smysl (%i < %i)\n",
			 l, infol.zavislost_na, infol.rychlost[i],
			 infot.rychlost[i]);
	      }
	}

    }
  return 0;
}
