#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "struktury.h"

/* argumenty.c */
char *argumenty (int, char **);

/* barvy.c */
void barevne ();

/* button.c */
int button_semafor_init (void);
int button_semafor_destroy (void);
int button_wait (int);
int button (char **, int, int, int, int, int, int);

/* cestina.c */
int cestina (int);

/* getch3.c */
int getch3 (void);

/* global.c */
int global_semafor_init (void);
int global_semafor_destroy (void);
short int global_get (enum_global);
void global_set (enum_global, short int);

/* copyright.c */
void copyright (void);

#include "profi/lib-h-info.h"

/* infolekce.c */
type_informace informace_o_lekcich (int, type_uziv *);

/* infotest.c */
type_informace informace_o_testech (int, type_uziv *);

/* infoklavesy.c */
int najdi_znak (char, char *);
void vytiskni_pismena (int, int, char *, char *, char *, int);

/* jmeno_adresare_hlavni.c */
char *jmeno_adresare_hlavni (void);

/* jmenasouboru.c */
char *jmeno_adresare_hlavni (void);
char *jmeno_temp_soubor (void);
char *jmeno_napovedy (void);
char *jmeno_napovedy3 (void);
char *jmeno_menu (void);
char *jmeno_adresare_psani (void);
char *jmeno_adresare (void);
char *jmeno_souboru (void);
char *jmeno_souboru_nastaveni (void);
char *jmeno_lekce00 (void);
char *jmeno_lekceXX (short int);
char *jmeno_napovedy_lekce (int);
char *jmeno_info_lekce (void);
char *jmeno_testu00 (void);
char *jmeno_testuXX (short int);
char *jmeno_napovedy_testu (int);
char *jmeno_info_testu (void);
char *jmeno_nov_text (char *);

#include "profi/lib-h-lock.h"

/* main.c */
void konec (char *);		/* ukonci vlakna, knihovnu kurses, odemkne a 
				   ukonci program */

/* menu.c */
/* viz. menu.h */

/* menu_funkce.c */
/* viz. menu.h */

/* nactiinfo.c */
#include "profi/lib-h-nactiinfo.h"
int nacti_info (int, type_informace *, char *);

/* nactiradek.c */
int nacti_radek (char *, int, FILE *);

/* nactislozku.c */
int otevri_adresar (char **c);
int nacti_slozku (type_uziv *, char **);
void implicitni_nastaveni (type_nastaveni *);
int nacti_nastaveni (type_nastaveni *, char **);

/* napoveda.c */
void napoveda (void);

/* napovedalekce.c */
void vypis_napoveda_lekce (int);

/* napovedatestu.c */
void vypis_napoveda_testu (int);

/* nast_metronom.c */
void nast_metronom (type_nastaveni *);
void vypis_metronom (type_nastaveni *);

/* nast_nov_text.c */
void nast_nov_text (type_nastaveni *);
void vypis_info_vtext (type_nastaveni *);

/* okna_obnov.c */
void obnov_nadpis1 (type_uziv *, type_nastaveni *);
void obnov_nadpis2 (type_uziv *, type_nastaveni *, type_odstavec *);
void obnov_nadpis3 (type_uziv *, type_nastaveni *, type_odstavec *, int);
void obnov_nadpis (void);
void obnov_informace (void);
void obnov_hlavni (void);
void obnov_psani (void);
void obnov_radek1 (char *, int i, unsigned int, unsigned int, unsigned int,
		   unsigned int, int);
void print_hl (int pocet, ...);

/* pbadresar.c */
int pbadresar (void);

/* pisradek.c */
int pis_radek (unsigned int *, char *, int, unsigned int *, unsigned int *,
	       int, boolean);

/* prihlaseni.c */
int prihlaseni (char **, type_uziv *, type_nastaveni *);

/* qwertz.c */
void qwertz (type_nastaveni *);

/* root_varovani.c */
void root_varovani (void);

/* secti_znaky.c */
unsigned int hodnota_znaku (char);
unsigned int secti_znaky (char *);

/* sifruj.c */
void sifruj (char *, unsigned int);

/* signal.c */
/* void signal_int(int);
void signal_quit(int);
void signal_term(int); 
void signal_trap(int); */
void signal_nastavit (void);

/* spust_nov_text.c */
int inicializuj_nov_text (type_odstavec *, char *);
int spust_nov_text (type_uziv *, type_nastaveni *, type_odstavec *);

/* spustlekci.c */
int inicializuj_lekci (type_uziv *, type_odstavec *);
int spust_lekci (type_uziv *, type_nastaveni *, type_odstavec *);

/* spusttest.c */
int inicializuj_test (type_uziv *, type_odstavec *);
int spust_test (type_uziv *, type_nastaveni *, type_odstavec *);

/* textnapovedy.c */
char *text_n (void);
char *text_n2 (void);
type_vety text_n3 (void);

/* ulozslozku.c */
int uloz_soubor (void *, size_t, char *);
int uloz_slozku (type_uziv *);
int uloz_nastaveni (type_nastaveni *);

/* ustocz.c */
int ustocz (int);

/* vlakna.c */
void vlakna (type_uziv *, type_nastaveni *);
void vlakna_konec (void);

/* vl_sporic.c */
/* void ukonci_vlakno_sporice(void); */

/* vyber_nov_text.c */
char *vyber_nov_text (void);

/* vyberlekci.c */
int vyber_lekci (type_uziv *, type_nastaveni *, int, int);

/* vybertest.c */
int vyber_test (type_uziv *, type_nastaveni *, int, int);

/* vyhodnot_nov_text.c */
void vyhodnot_nov_text (type_nastaveni *, type_odstavec *, type_znamka);

/* vyhodnotlekci.c */
int vyhodnot_lekci (type_uziv *, type_odstavec *, type_informace,
		    type_znamka);

/* vyhodnottest.c */
void vyhodnot_test (type_uziv *, type_odstavec *, type_informace,
		    type_znamka, int);
/* vypis_info.c */
void vypis_info (type_informace, type_nastaveni *);

/* vypis_napoveda.c */
void vypis_napoveda (char *, boolean);

/* vypis_vyhodnoceni.c */
void vypis_vyhodnoceni (type_odstavec *, type_informace, type_znamka,
			char **);

/* vysledky.c */
void vysledky (type_uziv *);

/* windows.c */
int windows (char **, type_uziv *);
#include "profi/lib-h-windows.h"

/* zamek.c */
int zamkni (void);
void odemkni (void);

/* znamky.c */
type_znamka znamka_lekce (type_informace, unsigned int, unsigned int,
			  unsigned int);
type_znamka znamka_nov_lekce (type_vtext, unsigned int, unsigned int,
			      unsigned int);
type_znamka znamka_z (unsigned int[5], unsigned int[5],
		      unsigned int, unsigned int, unsigned int);
