/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne licenese GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor nactiinfo.c */

#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "struktury.h"
#include "lib.h"
#define SIZEKOMENTAR 100
#define SIZEKLAVESY 80
#define SIZEPISMENA 160
#define SIZENOVEPISMENA 40
int nacti_info_jedno (FILE *, type_informace *);

#include "profi/nactiinfo-c-fce.h"

int
nacti_info_jedno (FILE * soubor, type_informace * L)
{
  char temp[255];
  unsigned short int i, j;
  if (6 != fscanf
      (soubor, "%10s%4u%4u%4u%4u%4u", temp, &L->presnost[0],
       &L->presnost[1], &L->presnost[2], &L->presnost[3], &L->presnost[4]))
    return 1;
  if (strcmp ("presnost:", temp))
    return 1;

  if (6 != fscanf
      (soubor, "%10s%4u%4u%4u%4u%4u", temp, &L->rychlost[0],
       &L->rychlost[1], &L->rychlost[2], &L->rychlost[3], &L->rychlost[4]))
    return 1;
  if (strcmp ("rychlost:", temp))
    return 1;

  if (!fscanf (soubor, "%11s%4i", temp, &L->zavislost_na))
    return 1;
  if (strcmp ("zavislost:", temp))
    return 1;
  if (!fscanf (soubor, "%10s%4i", temp, &L->mezernik))
    return 1;
  if (strcmp ("mezernik:", temp))
    return 1;
  if (!fscanf (soubor, "%100s", temp))
    return 1;
  if (strcmp ("komentar:", temp))
    return 1;
  if (!fgets (L->komentar, SIZEKOMENTAR, soubor))
    return 1;
  L->komentar[strlen (L->komentar) - 1] = '\0';

  if (!fscanf (soubor, "%9s", temp))
    return 1;
  if (strcmp ("klavesy:", temp))
    return 1;
  if (!fgets (L->klavesy, SIZEKLAVESY, soubor))
    return 1;
  if (!fscanf (soubor, "%160s", L->pismena))
    return 1;
/*    strncat(L->klavesy, temp, SIZEKLAVESY); */

  if (!fscanf (soubor, "%14s", temp))
    return 1;
  if (strcmp ("nove_pismena:", temp))
    return 1;

  if (!fgets (L->nove_pismena, SIZENOVEPISMENA, soubor))
    return 1;

  j = 0;
  for (i = 0; i < strlen (L->nove_pismena); i++)
    {
      if ((L->nove_pismena[i] != ' ') && (L->nove_pismena[i] != '\n')
	  && (L->nove_pismena[i] != '\t'))
	j = 1;
      else if (L->nove_pismena[i] == '\n')
	L->nove_pismena[i] = '\0';
    }
  if (!j)
    strcpy (L->nove_pismena, "");

  return 0;
}

int
nacti_info (int l, type_informace * L, char *jmeno_soub)
{
#ifndef PSANIPROFI
  FILE *soubor;
  char temp[255];
#endif
  static char komentar[SIZEKOMENTAR];
  static char klavesy[SIZEKLAVESY];
  static char pismena[SIZEPISMENA];
  static char nove_pismena[SIZENOVEPISMENA];

  /* toto musi byt nazacatku (pred prvnim return) */
  if (strcmp (jmeno_soub, jmeno_info_testu ()))
    L->test = 0;		/* je to test */
  else
    L->test = 1;		/* je to lekce */
  L->komentar = komentar;
  L->klavesy = klavesy;
  L->pismena = pismena;
  L->nove_pismena = nove_pismena;
  strcpy (L->komentar, "");
  strcpy (L->klavesy, "");
  strcpy (L->pismena, "");
  strcmp (L->nove_pismena, "");
  L->zavislost_na = (MAXLEKCE > MAXTEST) ? MAXLEKCE : MAXTEST;
#include "profi/nactiinfo-c-l.h"
#ifndef PSANIPROFI
  if ((soubor = fopen (jmeno_soub, "rt")) == NULL)
    {
      return 1;
    }

  do
    {
      if (feof (soubor))
	return 1;
      if (!fscanf (soubor, "%255s", temp))
	return 1;
      if (strcmp ("cislo:", temp))
	continue;
      if (!fscanf (soubor, "%4i", &L->cislo))
	return 1;
      if (L->cislo == l)
	break;
    }
  while (1);

  if (nacti_info_jedno (soubor, L))
    {
      fclose (soubor);
      return 1;
    }

  fclose (soubor);
  return 0;
#endif
}
