/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor pbadresar.c */

#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <pwd.h>

#include "struktury.h"
#include "lib.h"

int
pbadresar (void)
{				/* pouze vytvari adresar. Jmeno ziskava funkce 
				   jmeno_adresare() */
  DIR *adr;
  char adresar[NAME_MAX];
#ifndef  FLOPPY
  struct passwd *pw;
#endif

#ifdef FLOPPY			/* psani je umistene na bootovatelne diskete */
  strcpy (adresar, "/floppy/.");
#else
  if ((pw = getpwuid (getuid ())) == NULL)
    {
      if (global_get (g_warning) == g_w_ano)
	fprintf (stderr, "Nelze zjistit domovsky adrear uzivatele.");
      return 1;
    }
  strncpy (adresar, pw->pw_dir, sizeof (adresar) / sizeof (adresar[0]));
  strncat (adresar, "/.", NAME_MAX - strlen (adresar) - 1);
#endif
  strncat (adresar, PBADRESAR, NAME_MAX - strlen (adresar) - 1);

  if ((adr = opendir (adresar)) == NULL)
    {
      if ((mkdir (adresar, S_IRUSR | S_IWUSR | S_IXUSR |
		  S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH)) != 0)
	{
	  if (global_get (g_warning) == g_w_ano)
	    fprintf (stderr,
		     "pdadresar(): Nelze vytvorit adresar \"%s\"\n", adresar);
	  return 1;
	}
    }
  else
    closedir (adr);

  return 0;
}
