/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor signal.c */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include "struktury.h"
#include "lib.h"
#include "vlakna.h"

#define OPAKOVAT POCETVLAKEN	/* pri castem mackani ^c hrozi zatuhnuti !! */

static short int sem = OPAKOVAT - 1;
static char x;

void
signal_hlaska (char *signal)
{
  if (x)			/* TODO: semafory */
    return;
  x = 1;
  if (global_get (g_run) == g_run_t)
    print_hl (2, signal, " Psan testu nelze ukonit! Pijdete o 1 pokus!");
  else
    print_hl (2, signal,
	      " Pro ukonen pouvejte klvesy \"k\", <BACKSPACE>, F10 ...");
  x = 0;
}

#define PODM1a if (sem >= OPAKOVAT) {
#define PODM1b sem = 0;\
        } else {\
	sem++;\
	}

void
signal_int (int sig)
{
  PODM1a signal_hlaska ("(SIGINT)");
PODM1b}


void
signal_quit (int sig)
{
  PODM1a signal_hlaska ("(SIGQUIT)");
PODM1b}

void
signal_term (int sig)
{
  PODM1a signal_hlaska ("(SIGTERM)");
PODM1b}

void
signal_trap (int sig)
{
  PODM1a signal_hlaska ("(SIGTRAP)");
PODM1b}

void
signal_nastavit (void)
{
  struct sigaction act;

  if (sigemptyset (&act.sa_mask) && (global_get (g_warning) == g_w_ano))
    {
      fprintf (stderr, "sigemptyset: Nelze nastavit signaly");
      return;
    }
  act.sa_flags = SA_RESTART;

#define SIGNASTAV(s) if (sigaddset(&act.sa_mask, s) || \
	sigaction(s,&act,NULL) || sigfillset(&act.sa_mask)) {\
  if (global_get(g_warning) == g_w_ano) \
	fprintf(stderr,"sigaddset: Nelze nastavit signaly %i",(int) s); \
return;\
}

  act.sa_handler = signal_int;
  SIGNASTAV (SIGINT) act.sa_handler = signal_quit;
  SIGNASTAV (SIGQUIT) act.sa_handler = signal_term;
  SIGNASTAV (SIGTERM) act.sa_handler = signal_trap;
SIGNASTAV (SIGTRAP)}
