/* Copyright (c) 2004 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* vypis_vyhodnoceni.c */

#include "strukturyw.h"
#include "box3.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "barvy.h"

#define STEMP_SIZE 43

void
vypis_vyhodnoceni (type_odstavec * odstavec,
		   type_informace informace, type_znamka z, char **text)
{
  WINDOW *new_hodnoceni;
  unsigned short int i;
  char stemp[STEMP_SIZE];

  if ((new_hodnoceni = newwin2 (21, 43, 2, 14)) == NULL)
    {
      print_hl (1, "CHYBA: Nelze zobrazit hodnocen\n");
      if (global_get (g_warning) == g_w_ano)
	perror ("vypis_vyhodnoceni()");
      return;
    }

  wattron2 (new_hodnoceni, COLOR_PAIR (COLOR_HODNOCENI_HLAVNI));

  sprintf (stemp, "%*c", STEMP_SIZE - 1, ' ');
  for (i = 0; i < 21; i++) {
    mvwprintw2 (new_hodnoceni, i, 0, stemp);
  }

  mvwprintw2 (new_hodnoceni, 1, 2, text[0]);

  mvwprintw2 (new_hodnoceni, 2, 2, "- der -------------------------------");
  MVWPRINTW2 (new_hodnoceni, 3, 2, "Celkem/istch             =%4u/%u",
	      odstavec->oznaku, z.cznak);

  mvwprintw2 (new_hodnoceni, 5, 2, "- Chyby -------------------------------");
  MVWPRINTW2 (new_hodnoceni, 6, 2, "Poet chyb                 = %3u",
	      z.chyb);
  MVWPRINTW2 (new_hodnoceni, 7, 2, "Povolen procento chyb     = %6.2f%%",
	      (float) (informace.presnost[3] +
		       informace.presnost[4]) / 200.0);
  MVWPRINTW2 (new_hodnoceni, 8, 2, "Procento chyb              = %6.2f%%",
	      z.proc_chyb);
  wattron2 (new_hodnoceni, A_BOLD);
  MVWPRINTW2 (new_hodnoceni, 9, 2, "Znmka za pesnost:          %6.2f",
	      z.znamka_presnost);
  wattroff2 (new_hodnoceni, A_BOLD);
  mvwprintw2 (new_hodnoceni, 10, 2,
	      "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

  mvwprintw2 (new_hodnoceni, 11, 2,
	      "- Rychost -----------------------------");
  mvwprintw2 (new_hodnoceni, 12, 2, "Doba psan:                ");

  i = (int) z.vterin / 3600;
  sprintf (stemp, "%02i:", i);
  wprintw2 (new_hodnoceni, stemp);
  i = (int) ((z.vterin - (i) * 3600) / 60);
  sprintf (stemp, "%02i.", i);
  wprintw2 (new_hodnoceni, stemp);
  i = (int) (z.vterin - ((int) z.vterin / 60) * 60);
  sprintf (stemp, "%02i", i);
  wprintw2 (new_hodnoceni, stemp);

  MVWPRINTW2 (new_hodnoceni, 13, 2, "Minimln hoz            = %6u",
	      (informace.rychlost[3] + informace.rychlost[4]) / 2);
  MVWPRINTW2 (new_hodnoceni, 14, 2, "hoz za minutu            = %6u",
	      z.uh_min);
  wattron2 (new_hodnoceni, A_BOLD);
  MVWPRINTW2 (new_hodnoceni, 15, 2, "Znmka za rychlost:          %6.2f",
	      z.znamka_cas);

  wattroff2 (new_hodnoceni, A_BOLD);
  mvwprintw2 (new_hodnoceni, 16, 2,
	      "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");

  wattron2 (new_hodnoceni, A_BOLD);
  MVWPRINTW2 (new_hodnoceni, 18, 2, "Celkov znmka:              %6.2f",
	      z.znamka);

  wattroff2 (new_hodnoceni, A_BOLD);
  mvwprintw2 (new_hodnoceni, 19, 2,
	      "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
  box3 (new_hodnoceni, ':', '.');
  if (text[1])
    mvwprintw2 (new_hodnoceni, 20, 2, text[1]);
  if (text[2])
    wprintw2 (new_hodnoceni, text[2]);
  wattroff2 (new_hodnoceni, A_BOLD);

  print_hl (1, "Pokraujte klvesou \"k\" !");
  pridej_do_priority_w (1, new_hodnoceni, stdscr, LINES - 1, 0);
  tiskni_dle_priority ();
  while (getch3 () != 'k');

  odeber_z_priority (new_hodnoceni);
  delwin2 (new_hodnoceni);
  tiskni_dle_priority ();
}
